macroScript AnimationEffectors
category:"GregoryMaxScript" 
icon: #("Ef_icon", 1)	 (



try (closeRolloutFloater AnimationEffectors) catch()



rollout ScaleEffector "Size Effector" rolledup:true (
	
	local p
	local d = #()
	
	
	button CE "Create Effector" width: 160 height:40 images:#("AddScaleEf.bmp", "", 1,1,1,1,1) tooltip:"Select objects and press this button"
	progressbar pb "" 
	--checkbox db "Display as boxes" align:#center

	
	
		on CE pressed do (
			
			if selection.count == 0 then messagebox "Select objects!" beep:false title:"Selection"
			
			if selection.count > 0 then (
				
				undo on (
				
				p = dummy  name: "ScaleEffector"
		
				textP = text size:8 wirecolor:yellow text:"SE" 
				tScr = textP.position.controller =	position_script()
				tScr.addNode "d" p
				tScr.script = "d.pos"	

				

										ScaleCtrlAtr = attributes ScaleExp
										(
											
										parameters main rollout:ScalePrm
										(
										MinS type:#float ui:MinS default:0.05
										MaxS type:#float ui:MaxS default:1
										Rad type:#float ui:Rad default:30
										ShowP type:#boolean ui:ShowP default:true
										)	
											
											

										rollout ScalePrm "Scale Parameters"
										(
										group "Main"	(
										spinner MinS "Min scale" type: #float range:[0.000, 1, 0.05]
										spinner MaxS "Max scale" type: #float range:[0.001, 1000000, 1]
										spinner Rad "Effect Radius" type: #float range:[-100000, 100000, 30]	)
										group "Display" (
										checkbox ShowP "Show Points"	)
										
											
										

										) 




										)

										CustAttributes.add p ScaleCtrlAtr	

						 obs = selection as array 
										
										
						sg = SphereGizmo()
						sg.wirecolor = red
						sgsr = sg.position.controller = position_script()
						sgsr.addNode "p" p
						sgsr.script = "p.pos"				
						sg.showFrozenInGray = off				
						sgs = sg.radius.controller = float_script()	
						sgs.addTarget "rad" p.baseObject.ScaleExp[3]
						sgs.script = "rad"				
                         
												for i = 1 to obs.count do (
													
													
													
													d[i] = point  box:off  centermarker:on  axistripod:off cross:off wirecolor:yellow
													d[i].pos = obs[i].pos
													d[i].centermarker.controller = float_script()
													d[i].centermarker.controller.addTarget "p" p.baseObject.ScaleExp[4]
													d[i].centermarker.controller.script = "if p == true then 1 else 0"
													
													
													obs[i].scale.controller = scale_script()
													scr = obs[i].scale.controller
													scr.addNode "p" p
													scr.addNode "d" d[i]
													scr.addTarget "mn" p.baseObject.ScaleExp[1]
													scr.addTarget "mx" p.baseObject.ScaleExp[2]
													scr.addTarget "rad" p.baseObject.ScaleExp[3]
				                                    scr.script = "if p!=undefined and d!=undefined then (dis = distance p d\n sF = dis/rad\n if sF < mn then sF = mn\n if sF> mx then sF = mx\n [sF, sF, sF]) else [1, 1, 1]"
													
													pb.value = (100*i/obs.count)
													pb.color = (color 80 (255*i/obs.count) (255*i/obs.count) )
													
												)
				
				select p
												
											)
				
			)
		
		)
	
	
)



rollout PosEffector "Position Effector" rolledup:true (
	
	
	button CE "Create Effector" width: 160 height:40 images:#("AddPosEf.bmp", "", 1,1,1,1,1) tooltip:"Select objects and press this button"
	progressbar pb "" 	
	
	
	
	
	on CE pressed do (
	
	
				if selection.count == 0 then messagebox "Select objects!" beep:false title:"Selection"
			
			if selection.count > 0 then (
				
				undo on (
					
					
					s = selection as array 

main_dummy = dummy()
textP = text size:8 wirecolor:green text:"PE" 
tScr = textP.position.controller =	position_script()
tScr.addNode "d" main_dummy
tScr.script = "d.pos"
					
main_dummy.name = "PositionEffector"
dummy_arr = #()


										OffsetAtr = attributes OffsetVal
										(
											
										parameters main rollout:OffsetRoll
										(
										OffsetX type:#float ui:OffsetX default:0.0
										OffsetY type:#float ui:OffsetY default:0.0	
										OffsetZ type:#float ui:OffsetZ default:0.0
										ShowP type:#boolean ui:ShowP default:true	
										Mult type:#float ui:Mult default:2	
	
										)	
											
											

										rollout OffsetRoll "Position Parameters"
										(
										
										group "Main"	(
										spinner OffsetX "Offset X" type: #float range:[-1000000, 100000, 0.0]
										spinner OffsetY "Offset Y" type: #float range:[-1000000, 100000, 0.0]
										spinner OffsetZ "Offset Z" type: #float range:[-1000000, 100000, 0.0]
										spinner Mult "Multiplier" type: #float range:[-1000000, 100000, 2]	
											
											
										)
											
											
										group "Display" (
										checkbox ShowP "Show Points"	)

										
											
										

										) 




										)

										CustAttributes.add main_dummy OffsetAtr











for i = 1 to s.count do (
	
	
	dummy_arr[i] = point  box:off  centermarker:on  axistripod:off cross:off wirecolor:green
	dummy_arr[i].pos = s[i].pos
	
	dummy_arr[i].centermarker.controller = float_script()
	dummy_arr[i].centermarker.controller.addTarget "p" main_dummy.baseObject.OffsetVal[4]
	dummy_arr[i].centermarker.controller.script = "if p == true then 1 else 0"
	
	
	ps = s[i].position.controller = position_script()
	ps.addNode "d" dummy_arr[i]
	ps.addTarget "ofs_x" main_dummy.baseObject.OffsetVal[1]
	ps.addTarget "ofs_y" main_dummy.baseObject.OffsetVal[2]
	ps.addTarget "ofs_z" main_dummy.baseObject.OffsetVal[3]
	ps.addTarget "mult" main_dummy.baseObject.OffsetVal[5]
	

	
	ps.script =  "if d!=undefined then (x = d.pos.x+(ofs_x*"+((i) as string)+"^mult)\n"+"y = d.pos.y+(ofs_y*"+(i as string)+")\n"+"z = d.pos.z+(ofs_z*"+(i as string)+")\n"+"[x, y, z]) else [0, 0, 0]"
	
	pb.value = (100*i/s.count)
	pb.color = (color 80 (255*i/s.count) (255*i/s.count) )
	
	
	
)

select main_dummy
		
				)
	
	
	
	
	
			)
	
	
	
)
	
	
	
	
	
)


rollout RotEffector "Rotation Effector" rolledup:true (
	
	
	button CE "Create Effector" width: 160 height:40 images:#("AddRotEf.bmp", "", 1,1,1,1,1) tooltip:"Select objects and press this button"
	progressbar pb "" 	
	
	
	
	
	on CE pressed do (
	
	
				if selection.count == 0 then messagebox "Select objects!" beep:false title:"Selection"
			
			if selection.count > 0 then (
				
          undo on (
			  
d = dummy()
d.name = "RotationEffector"

									RotAtr = attributes RotExp
										(
											
										parameters main rollout:RotPrm
										(
										SpeedX type:#float ui:SpeedX default:0.01
										SpeedY type:#float ui:SpeedY default:0.01
										SpeedZ type:#float ui:SpeedZ default:0.01	
										Rad type:#float ui:Rad default:100
										)	
											
											

										rollout RotPrm "Rotation Parameters"
										(
										group "Rotation"	(
										spinner SpeedX "Speed X" type: #float range:[-1000000, 1000000, 0.01]
										spinner SpeedY "Speed Y" type: #float range:[-1000000, 1000000, 0.01]
										spinner SpeedZ "Speed Z" type: #float range:[-1000000, 1000000, 0.01]
										spinner Rad "Effect Radius" type: #float range:[-1000000, 1000000, 100]	
											)
										
											
										

										) 




										)

										CustAttributes.add d RotAtr
										
										


s = selection as array 
										
										
						sg = SphereGizmo()
						sg.wirecolor = red
						sgsr = sg.position.controller = position_script()
						sgsr.addNode "p" d
						sgsr.script = "p.pos"				
						sg.showFrozenInGray = off				
						sgs = sg.radius.controller = float_script()	
						sgs.addTarget "rad" d.baseObject.RotExp[4]
						sgs.script = "rad"											

textP = text size:8 wirecolor:red text:"RE" 
tScr = textP.position.controller =	position_script()
tScr.addNode "d" d
tScr.script = "d.pos"




for i = 1 to s.count do (
	
	x_rot = s[i].rotation.controller.x_rotation.controller = float_script()
	y_rot = s[i].rotation.controller.y_rotation.controller = float_script()
	z_rot = s[i].rotation.controller.z_rotation.controller = float_script()
	
	x_rot.addNode "d" d
	y_rot.addNode "d" d
	z_rot.addNode "d" d
	
	x_rot.addNode "rE" s[i]
	y_rot.addNode "rE" s[i]
	z_rot.addNode "rE" s[i]
	
	x_rot.addTarget "sP" d.baseObject.RotExp[1]
	y_rot.addTarget "sP" d.baseObject.RotExp[2]
	z_rot.addTarget "sP" d.baseObject.RotExp[3]
	
	x_rot.addTarget "rd" d.baseObject.RotExp[4]
	y_rot.addTarget "rd" d.baseObject.RotExp[4]
	z_rot.addTarget "rd" d.baseObject.RotExp[4]
	
	
	x_rot.script = "if d!=undefined and rE!=undefined then (dis = distance d rE\n if dis < rd then (dis*sP) else 0)"
    y_rot.script = "if d!=undefined and rE!=undefined then (dis = distance d rE\n if dis < rd then (dis*sP) else 0)"
	z_rot.script = "if d!=undefined and rE!=undefined then (dis = distance d rE\n if dis < rd then (dis*sP) else 0)"
	
	pb.value = (100*i/s.count)
	pb.color = (color 80 (255*i/s.count) (255*i/s.count) )
	
	
)		  
			  
			  
			  
	
	
	
		  )
	
			)
	
	
	
)
	
	
	
	
	
)

rollout ShellEffector "Shell Effector" rolledup:true (
	
	local p
	local d = #()
	
	
	button CE "Create Effector" width: 160 height:40 images:#("AddShellEf.bmp", "", 1,1,1,1,1) tooltip:"Select objects and press this button"
	progressbar pb "" 
    --checkbox db "Display as boxes" align:#center
	
	
		on CE pressed do (
			
			if selection.count == 0 then messagebox "Select objects!" beep:false title:"Selection"
			
			if selection.count > 0 then (
				
				undo on (
				
				p = dummy  name: "ShallEffector"
				textP = text size:8 wirecolor:blue text:"SE" 
				tScr = textP.position.controller =	position_script()
				tScr.addNode "d" p
				tScr.script = "d.pos"		

				

										ShellCtrlAtr = attributes ShellExp
										(
											
										parameters main rollout:ShellPrm
										(
										MinS type:#float ui:MinS default:0.05
										MaxS type:#float ui:MaxS default:1
										Rad type:#float ui:Rad default:30
										ShowP type:#boolean ui:ShowP default:true
										)	
											
											

										rollout ShellPrm "Shell Parameters"
										(
										group "Main"	(
										spinner MinS "Min shell" type: #float range:[0.000, 1, 0.05]
										spinner MaxS "Max shell" type: #float range:[0.001, 1000000, 1]
										spinner Rad "Effect Radius" type: #float range:[-100000, 100000, 30]	)
										group "Display" (
										checkbox ShowP "Show Points"	)
										
											
										

										) 




										)

										CustAttributes.add p ShellCtrlAtr	

						 obs = selection as array 
										
										
						sg = SphereGizmo()
						sg.wirecolor = blue
						sgsr = sg.position.controller = position_script()
						sgsr.addNode "p" p
						sgsr.script = "p.pos"				
						sg.showFrozenInGray = off				
						sgs = sg.radius.controller = float_script()	
						sgs.addTarget "rad" p.baseObject.ShellExp[3]
						sgs.script = "rad"				
                         
												for i = 1 to obs.count do (
													
													
													
													d[i] = point  box:off  centermarker:on axistripod:off cross:off wirecolor:blue
													d[i].pos = obs[i].pos
													d[i].centermarker.controller = float_script()
													d[i].centermarker.controller.addTarget "p" p.baseObject.ShellExp[4]
													d[i].centermarker.controller.script = "if p == true then 1 else 0"
													
													slm = Shell()
													addmodifier obs[i] slm
													sC = obs[i].modifiers[1].OuterAmount.controller = float_script()
													sC.addNode "p" p
													sC.addNode "d" obs[i]
													sC.addTarget "mn" p.baseObject.ShellExp[1]
													sC.addTarget "mx" p.baseObject.ShellExp[2]
													sC.addTarget "rad" p.baseObject.ShellExp[3]
				                                    sC.script = "if p!=undefined and d!=undefined then (dis = distance p d\n sF = dis/rad\n if sF < mn then sF = mn\n if sF> mx then sF = mx\n sF) else 5"
													
													pb.value = (100*i/obs.count)
													pb.color = (color 80 (255*i/obs.count) (255*i/obs.count) )
													
												)
				
				select p
												
											)
				
			)
		
		)
	
	
)


rollout Frag "Fragmental" (
	
function Fractal_X main_obj sl_angle  =  (

undo on (

main_obj = selection as array 


for i = 1 to main_obj.count do (

	fragments_x = #()

	
if superclassof main_obj[i] == GeometryClass   then  (
	
	
	centerpivot main_obj[i]
	resetxform main_obj[i]
	fragments_x[1] = copy main_obj[i] 
	fragments_x[1].wirecolor =  (color (random 0 255) (random 0 255) (random 0 255))
	delete main_obj[i] 

	slice = SliceModifier()
	cap = Cap_Holes()

	addmodifier fragments_x[1] slice
	addmodifier fragments_x[1] cap


	slice.slice_plane.rotation.x_rotation = sl_angle
	slice.slice_type = 2
	centerpivot fragments_x[1] 
	resetxform  fragments_x[1]	
		
	fragments_x[2] = copy fragments_x[1]
	fragments_x[2].wirecolor =  (color (random 0 255) (random 0 255) (random 0 255))	
	fragments_x[2].modifiers[#slice].slice_type = 3	
	centerpivot fragments_x[2]
	resetxform fragments_x[2]
	converttopoly fragments_x[1]	
	converttopoly fragments_x[2]

		
	)	
		
	)
		
	)
	
)


function Fractal_Y main_obj sl_angle  =  (

undo on (

main_obj = selection as array 


for i = 1 to main_obj.count do (

	fragments_x = #()

	
if superclassof main_obj[i] == GeometryClass   then  (
	
	
	centerpivot main_obj[i]
	resetxform main_obj[i]
	fragments_x[1] = copy main_obj[i] 
	fragments_x[1].wirecolor =  (color (random 0 255) (random 0 255) (random 0 255))
	delete main_obj[i] 

	slice = SliceModifier()
	cap = Cap_Holes()

	addmodifier fragments_x[1] slice
	addmodifier fragments_x[1] cap


	slice.slice_plane.rotation.y_rotation = sl_angle
	slice.slice_type = 2
	centerpivot fragments_x[1] 
	resetxform  fragments_x[1]	
		
	fragments_x[2] = copy fragments_x[1]
	fragments_x[2].wirecolor =  (color (random 0 255) (random 0 255) (random 0 255))	
	fragments_x[2].modifiers[#slice].slice_type = 3	
	centerpivot fragments_x[2]
	resetxform fragments_x[2]
	converttopoly fragments_x[1]	
	converttopoly fragments_x[2]		
		
	)
		
	)
		
	)
	
)

function Fractal_Z main_obj sl_angle  =  (

undo on (

main_obj = selection as array 


for i = 1 to main_obj.count do (

	fragments_x = #()

	

if superclassof main_obj[i] == GeometryClass   then  (	
	
	centerpivot main_obj[i]
	resetxform main_obj[i]
	fragments_x[1] = copy main_obj[i] 
	fragments_x[1].wirecolor =  (color (random 0 255) (random 0 255) (random 0 255))
	delete main_obj[i] 

	slice = SliceModifier()
	cap = Cap_Holes()

	addmodifier fragments_x[1] slice
	addmodifier fragments_x[1] cap


	slice.slice_plane.rotation.z_rotation = sl_angle
	slice.slice_type = 2
	centerpivot fragments_x[1] 
	resetxform  fragments_x[1]	
		
	fragments_x[2] = copy fragments_x[1]
	fragments_x[2].wirecolor =  (color (random 0 255) (random 0 255) (random 0 255))	
	fragments_x[2].modifiers[#slice].slice_type = 3	
	centerpivot fragments_x[2]
	resetxform fragments_x[2]
	converttopoly fragments_x[1]	
	converttopoly fragments_x[2]
		
	)	
		
	)
		
	)
	
)
	
	
	button Fragmentall_X "Fragmentall X" width: 160 height: 40 images:#("Fragmental_X.bmp", "EfAlpha.bmp", 1,1,1,1,1)  
	button Fragmentall_Y "Fragmentall Y" width: 160 height: 40 images:#("Fragmental_Y.bmp", "EfAlpha.bmp", 1,1,1,1,1) 
	button Fragmentall_Z "Fragmentall Z" width: 160 height: 40 images:#("Fragmental_Z.bmp", "EfAlpha.bmp", 1,1,1,1,1)
    label lb "" 
	spinner RotationAngle "Slice Angle" range:[-360, 360, 90] align:#center
	
	local all = #()
	
	
	on Fragmentall_X pressed do ( 
		
		if selection.count == 0 then messagebox "Select one or more objects!" title:"Fragmental X" beep:false
			
		if selection.count > 0 then (all = selection as array; Fractal_X $ RotationAngle.value; lb.caption =(all.count as string)+" Objects Divided!") 

	)
	
	
	
	
	on Fragmentall_Y pressed do ( 
		
		if selection.count == 0 then messagebox "Select one or more objects!" title:"Fragmental Y" beep:false
			
		if selection.count > 0 then (all = selection as array; Fractal_Y $ RotationAngle.value; lb.caption =(all.count as string)+" Objects Divided!") 

	)
	
	
	
	on Fragmentall_Z pressed do ( 
		
		if selection.count == 0 then messagebox "Select one or more objects!" title:"Fragmental Z" beep:false
			
		if selection.count > 0 then (all = selection as array; Fractal_Z $ RotationAngle.value; lb.caption = "Objects Divided!"; lb.caption =(all.count as string)+" Objects Divided!") 

	)	
	
	
)	
	
	


rollout DetachP "DetachPolygons" (
	
	button DetachAllPolys "Detach" width:100 height:30
	checkbox ChangeWC "Change Warecolor" align:#center checked:true
	dropdownlist detach_type "" items:#("Polygons", "Objects")
	spinner detach_count "Detach objects:" type:#integer range:[1, 1000, 10] enabled:false
	
	on detach_type selected sel do (

		if sel == 1 then detach_count.enabled = false
		if sel == 2 then detach_count.enabled = true
	

	)		
	
	on DetachAllPolys pressed do (
		
	if selection.count == 0 then messagebox "Select one object!" beep:false title:"Error selection"
    if selection.count > 1 then messagebox "Select only one object!" beep:false title:"Error selection"		
	if detach_type.selection == 1 then ( 
		
		
		if selection.count == 1 then (
			
			
				obj = $
				converttoPoly obj
				for p = polyop.getNumFaces obj to 1 by -1 do (

				if ChangeWC.checked ==true then ( obj.wirecolor = (color (random 255 0) (random 255 0) (random 255 0)) )	
				polyOp.detachFaces obj #(p) asNode:true


				)

		)	
		
		
	)
	
	
	
	
	if detach_type.selection == 2 then ( 
		
		if selection.count == 1 then (
			
			
		obj = $
		convertToPoly obj

		for i = 1 to 7 do (

		if ChangeWC.checked ==true then ( obj.wirecolor = (color (random 255 0) (random 255 0) (random 255 0)) )	
		obj.EditablePoly.SetSelection #Face #{1}
		obj.Selectelement()
		hold = polyop.GetFaceSelection obj
		polyOp.detachFaces obj hold asNode:true
			
		)	
			


		)	
		
		
	)	
	
	
	)	
	
	
)



rollout CutTools "Tools" rolledup:true (
	
	button ShowFrag "Fragmental" across:2 width: 100 height:40 images:#("FragRoll.bmp", "", 1,1,1,1,1)
	button ShowDetach "Detach Polygons" width: 100 height:40 images:#("DtcPoly.bmp", "", 1,1,1,1,1)
	button PivotTocenter "Pivot To Center" width: 100 height:40 

	on ShowFrag pressed do (try DestroyDialog Frag catch(); CreateDialog Frag)
	on ShowDetach pressed do (try DestroyDialog DetachP catch(); CreateDialog DetachP)
	on PivotTocenter pressed do (if selection.count > 0 then (s = selection as array; for i = 1 to s.count do (centerpivot s[i])))
	
)




rollout AboutR "About" (
	
	hyperLink addr "Help" address:"http://www.youtube.com/channel/UC3VTDQImYNBTcsBxI9vuPIg" align:#center
	button lb "Tst" enabled:false width:260 height:161 images:#("AEL.bmp", "AEL_a.bmp", 1,1,1,1,1)
	
    
	
	
)


AnimationEffectors = NewRolloutFloater "Animation Effectors v1.0" 280 325
addrollout ScaleEffector AnimationEffectors
addrollout PosEffector AnimationEffectors
addrollout RotEffector AnimationEffectors
addrollout  ShellEffector AnimationEffectors
addrollout CutTools AnimationEffectors
addrollout  AboutR AnimationEffectors

)   


messagebox "Animation Effectors v1.0 Instaled! \nCategory:\"GregoryMaxScript\"" beep:false  title: "Complite!"